

#ifndef IWndTFrameDans_RULE_UIFrame_H
#define IWndTFrameDans_RULE_UIFrame_H


#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "IWndTFrame.h"
#include "IWndPaneDetail.h"
#include "IWndPaneMiniMap.h"
#include "IWndPaneCommand.h"


namespace OP2ForcedExport
{

	struct IniSettings
	{
		int scrollRate;
		int zoom;
		bool bShowAmbientAnimations;
		bool bShowComputerOverlay;
		bool b1;					// **
		bool bShowStationaryShadows;
		bool bShowMobileShadows;
		int b2[2];					// **
		int frameSkip;
		// -----------
		// Font
	};


	// Address: 0x5756C0
	// Base class min size: 0x14
	// Size: 
	class Dans_RULE_UIFrame : public TFrame
	{
	public:
		// Virtual member functions (IWnd)
		// -------------------------------
		virtual char const * RegisterClassA(void);
		virtual ~Dans_RULE_UIFrame();
		// virtual void Destroy();
		// virtual int CreateEx(unsigned long,char const *,unsigned long,int,int,int,int,HWND,HMENU,void*,HINSTANCE);
		virtual long WndProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
		virtual int CallFilters(UINT uMsg, WPARAM wParam, LPARAM lParam);
		// Virtual member functions (TFrame)
		// ---------------------------------
		virtual void ShutDown();
		// Note: Insert 5 virtual members here
		virtual void TFrame_F1(UIState*);
		virtual void TFrame_F2(unsigned int controlId);
		virtual void TranslateAccelerators(MSG* msg);
		virtual void Init();
		virtual void Initialize();
		// Note: End extra 5 virtual members
		virtual void Activate();
		virtual void Deactivate();
		virtual void OnIdle();
		virtual void PreCreateDlg();
		virtual void PostCreateDlg();

	public:
		// Member variables
		// ---------------------------
		// vtbl
		// bool bNotWindowOwner;
		// HWND hWnd;
		// FilterNode* linkedListHead;
		// FilterNode* linkedListTail;
		// ---------------------------
		HFONT hLargeFont;
		char largeMessage[80];
		int largeMessageLength;
		COLORREF textColor;
		Rect textRect;
		int b1[5];					// **
		int textY;
		int b2[2];					// **
		int displayedCommonOre;
		int displayedRareOre;
		int b3[2];					// **
		LARGE_INTEGER performanceFrequency;
		int milliSecOfLastProcessingLoop;
		int milliSecPerGameTick;
		int milliSecPerGameTick2;	// ** ?
		int b4[3];					// **
		LARGE_INTEGER performanceCount[16];
		int performanceCountIndex;
		int b5[0x23];				// **
		int gamePausedCount;
		HDC hBackgroundDC;
		HACCEL hViewAccel;
		HACCEL hUnitAccel;
		HACCEL hPauseAccel;
		// -----
		DetailPane detailPane;
		MiniMapPane miniMapPane;
		CommandPane commandPane;
		// -----
		int b6[0x2C];				// ** StatusBar
		// -----
		IniSettings settings;
		// Font
	};


	// Globals
	extern Dans_RULE_UIFrame dansFrame;

}	// End namespace


#endif
